VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "VU Meters"
   ClientHeight    =   2040
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2040
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ProgressBar ProgressBar2 
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   1380
      Width           =   4575
      _ExtentX        =   8070
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   255
      Left            =   60
      TabIndex        =   4
      Top             =   1680
      Width           =   4575
      _ExtentX        =   8070
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Stop"
      Height          =   315
      Left            =   2520
      TabIndex        =   3
      Top             =   720
      Width           =   915
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   1920
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   120
      Width           =   2655
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   315
      Left            =   1500
      TabIndex        =   0
      Top             =   720
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Enumerated devices:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   180
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sglValueL As Single
Dim sglValueR As Single

Private Sub InitDevices()
    Dim wicCaps As WaveInCaps
    Dim lngNumDev As Long
    'enumerate sound cards
    Combo1.Clear
    For lngNumDev = 0 To waveInGetNumDevs - 1
        Call waveInGetDevCaps(lngNumDev, VarPtr(wicCaps), Len(wicCaps))
        If wicCaps.Formats And WAVE_FORMAT_1S08 Then
            Combo1.AddItem StrConv(wicCaps.ProductName, vbUnicode) & Str(lngNumDev)
        End If
    Next
    If Combo1.ListCount = 0 Then
        Combo1.Text = "No audio devices available."
        Exit Sub
    End If
    'select the default sound card
    Combo1.ListIndex = 0
End Sub

Private Sub Command1_Click()
   Static WaveFormat As WaveFormatEx
   'set up capture parameters
   With WaveFormat
      .FormatTag = WAVE_FORMAT_PCM
      .Channels = 2
      .SamplesPerSec = 11025 '11khz
      .BitsPerSample = 8
      .BlockAlign = (.Channels * .BitsPerSample) \ 8
      .AvgBytesPerSec = .BlockAlign * .SamplesPerSec
      .ExtraDataSize = 0
   End With
   'open device and assign handle
   Debug.Print "waveInOpen:"; waveInOpen(DevHandle, Combo1.ListIndex, VarPtr(WaveFormat), 0, 0, 0)
   'did it?
   If DevHandle = 0 Then
      Call MsgBox("Failed to open wave in device.", vbExclamation)
      Exit Sub
   End If
   'yes!
   Debug.Print " "; DevHandle
   'lets go!
   Call waveInStart(DevHandle)
   Call CaptureSamples
End Sub

Private Sub Command2_Click()
    Call waveInReset(DevHandle)
    Call waveInClose(DevHandle)
    DevHandle = 0
    ProgressBar1.Value = 0
    ProgressBar2.Value = 0
End Sub

Private Sub Command3_Click()

End Sub

Private Sub Form_Load()
   Call InitDevices
   ProgressBar1.Max = 100
   ProgressBar2.Max = 100
   ProgressBar1.Value = 0
   ProgressBar2.Value = 0
End Sub

Private Sub CaptureSamples()
    Static Wave As WaveHdr
    Wave.lpData = VarPtr(InData(0))
    Wave.dwBufferLength = 512
    Wave.dwFlags = 0
    Do
        Call waveInPrepareHeader(DevHandle, VarPtr(Wave), Len(Wave))
        Call waveInAddBuffer(DevHandle, VarPtr(Wave), Len(Wave))
        'wait for buffer to fill
        Do
           DoEvents
        Loop Until ((Wave.dwFlags And WHDR_DONE) = WHDR_DONE) Or DevHandle = 0
        'and clean up
        Call waveInUnprepareHeader(DevHandle, VarPtr(Wave), Len(Wave))
        
        If DevHandle = 0 Then
           Exit Do
        End If
        'display the result
        Call LevelMeters
                
        DoEvents
    Loop While DevHandle <> 0

End Sub

Private Sub LevelMeters()
   Dim i As Integer
   Dim intAudioL As Integer
   Dim intAudioR As Integer
   Dim sglDifferenceL As Single
   Dim sglDifferenceR As Single
   
   'Provide a VU Meter like display..
   For i = 0 To 255
      'half-wave rectify the audio
      intAudioL = (InData(i * 2) - 127)
      If intAudioL < 0 Then intAudioL = 0
      intAudioR = (InData((i * 2) + 1) - 127)
      If intAudioR < 0 Then intAudioR = 0
      'calculate the change
      sglDifferenceL = intAudioL - sglValueL
      sglDifferenceR = intAudioR - sglValueR
      'attack
      If sglDifferenceL > 0 Then sglValueL = sglValueL + (sglDifferenceL / 2)
      If sglDifferenceR > 0 Then sglValueR = sglValueR + (sglDifferenceR / 2)
      'decay
      If sglDifferenceL < 0 Then sglValueL = sglValueL + (sglDifferenceL / 100)
      If sglDifferenceR < 0 Then sglValueR = sglValueR + (sglDifferenceR / 100)
      'convert to log and update progress bars
      ProgressBar1.Value = Log(sglValueL + 1) * 20
      ProgressBar2.Value = Log(sglValueR + 1) * 20
      DoEvents
   Next
            
    
End Sub
